#include "header.h"


void main()
{
	DWORD len;
	char option[3];
	static char fname1[MAX_PATH];
	static char fname2[MAX_PATH];
	static char fname3[MAX_PATH];
	static char fname4[MAX_PATH];
	char* cmds = GetCommandLine();

	ReadCmdLineArg( 0, 0, cmds, &len ); // skip argv[0]
	cmds += len;
	ReadCmdLineArg( option, sizeof(option), cmds, &len ); 
	cmds += len;
	ReadCmdLineArg( fname1, sizeof(fname1), cmds, &len );
	cmds += len;
	ReadCmdLineArg( fname2, sizeof(fname2), cmds, &len );
	cmds += len;
	ReadCmdLineArg( fname3, sizeof(fname3), cmds, &len );
	cmds += len;
	ReadCmdLineArg( fname4, sizeof(fname4), cmds, &len );
	cmds += len;

	if( ( option[0] == '-' )  || ( option[0] == '/' ) )
	{
		if( ( ( option[1] == 'x' ) || ( option[1] == 'X' ) ) && ( option[2] == '\0' ) )
		{
			if( fname4[0] != '\0' )
			{
				Printf( "Error: Too many args \r\n" );
				goto lbl_end;
			}
			if( fname3[0] == '\0' )
			{
				Printf( "Error: Too few args.\r\n" );
				goto lbl_end;
			}

			HEIGHTMAP_INFO info;
			if( GetTERR( fname1, &info ) ){
				ExportPNG( fname2, &info, 0 );
				ExportPNG( fname3, &info, 1 );
				VirtualFree( info.file_buf, 0, MEM_RELEASE );
			}
			goto lbl_end;
		}
		else {
			if( ( ( option[1] == 'i' ) || ( option[1] == 'I' ) ) && ( option[2] == '\0' ) )
			{
				if( ReadCmdLineArg( 0, 0, cmds, &len ) > 1 ){ 
					Printf( "Error: Too many args \r\n" );
					goto lbl_end;
				}
				if( fname4[0] == '\0' )
				{
					Printf( "Error: Too few args.\r\n" );
					goto lbl_end;
				}

				Import( fname1, fname2, fname3, fname4 );
				goto lbl_end;
			}
			else {
				if( ( ( option[1] == 's' ) || ( option[1] == 'S' ) ) && ( option[2] == '\0' ) )
				{
					if( fname2[0] == '\0' )
					{
						ShowSeaLevel( fname1 );
						goto lbl_end;
					}
					else
					{
						SetSeaLevel( fname1, ReadOutInteger( fname2, 0 ) );
						goto lbl_end;
					}
				}
			}
		}
	}


	Printf( "TERR v0.01 by aqrit\r\n"
		"  Import/eXport Dark Omen heightmaps to/from 16-bit grayscale PNG image files.\r\n"
		"  terr -x in.prj out1.png out2.png\r\n"
		"  terr -i in.prj out.prj in1.png in2.png\r\n" 
		"  terr -s in_out.png [ sea_level ]\r\n\r\n"
	);

/*
	test( "B1_01.PRJ" );
	test( "B1_02.PRJ" );
	test( "B1_03.PRJ" );
	test( "B1_04.PRJ" );
	test( "B1_05.PRJ" );
	test( "B1_06.PRJ" );
	test( "B1_07.PRJ" );
	test( "B1_08.PRJ" );
	test( "B2_01.PRJ" );
	test( "B2_02.PRJ" );
	test( "B2_04.PRJ" );
	test( "B2_05.PRJ" );
	test( "B2_07.PRJ" );
	test( "B2_08.PRJ" );
	test( "B3_01.PRJ" );
	test( "B3_02.PRJ" );
	test( "B3_06.PRJ" );
	test( "B3_07.PRJ" );
	test( "B3_08.PRJ" );
	test( "B3_09.PRJ" );
	test( "B4_01.PRJ" );
	test( "B4_02.PRJ" );
	test( "B4_03.PRJ" );
	test( "B4_05.PRJ" );
	test( "B4_06.PRJ" );
	test( "B4_08.PRJ" );
	test( "B4_09.PRJ" );
	test( "B4_10.PRJ" );
	test( "B5_01.PRJ" );
	test( "B5_01B.PRJ" );
	test( "MB1_03.PRJ" );
	test( "MB1_04.PRJ" );
	test( "MB1_08.PRJ" );
	test( "MB2_04.PRJ" );
	test( "MB2_05.PRJ" );
	test( "MB3_06.PRJ" );
	test( "MB3_08.PRJ" );
	test( "MB4_01.PRJ" );
	test( "MB4_02.PRJ" );
	test( "MB4_09.PRJ" );
*/
lbl_end:
	ExitProcess( GetLastError() );
}




#pragma comment(linker,"/SUBSYSTEM:CONSOLE")
#pragma comment(linker,"/ENTRY:main")
#pragma comment(linker,"/NODEFAULTLIB")


 